

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 0
#property indicator_buffers 1
#property indicator_color1  DodgerBlue

//
//
//
//
//

extern double WprPeriod        = 14;
extern double levelOb          = -20.0;
extern double levelOs          = -80.0;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "wpr Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;
extern int    arrowsUpSize     = 2;
extern int    arrowsDnSize     = 2;

//
//
//
//
//

double wpr[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,wpr);
   SetIndexBuffer(1,trend);
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   IndicatorShortName( " %R (" +DoubleToStr(WprPeriod,2)+ ")");
   return(0);
}
int deinit() 
{  
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0); 
}
  
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           
   //
   //
   //
   //
   //
          
   for (int i=limit; i>=0; i--)
   {
       double hi   = High[iHighest(NULL,0,MODE_HIGH,WprPeriod,i)];
       double lo   =  Low[iLowest(NULL,  0,MODE_LOW,WprPeriod,i)];
       if (hi!=lo)      
            wpr[i] = -100*(hi - Close[i]) / (hi - lo);
       else wpr[i] = 0;
       
       trend[i] = trend[i+1];
       if(wpr[i]<levelOs) trend[i] = 1;
       if(wpr[i]>levelOb) trend[i] =-1; 
       if (ShowArrows)
       {
          ObjectDelete(arrowsIdentifier+":"+Time[i]);
          if (trend[i] != trend[i+1])
          {
            if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
            if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize, true);
          }
       }         
    }
    
    //
    //
    //
    //
    //
      
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("Buy");
      else  doAlert("Sell");       
    }
return(0);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theSize,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theSize);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," williams-r ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," williams-r " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," williams-r "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}